#include "main.h"

// Internal Iterative Deepening + Search In Root
int iid (int m_depth, board * B)
{
    int i, j, k, sz;
    int val, move;

    int last_val = - inf;   //
    int last_move = 0;     //  time management
    int cnt_ch_moves = 0; //

    int singular = 0;    // 
    int best_val [2];

    int values [256];    //   ( mp)
	int alpha, beta, depth, step;
	int best_i [ROOT_ORDERING];

	int steps [80] = {0, 0, 900, 500, 400, 350, 325, 310, 290, 270, 250, 240, 230, 220, 210, 200,};

	for (i = 0; i < 256; i ++) values [i] = 0;

    S->state = ANALYSING;
    S->best_move = 0; //    ( IID)

    //      
    init_arrays ();
    init_uci_info ();
    hash_calc (B);

	g_hash_age ++; //    aging'
	S->ply = 0;   //         

    //        
	board *N = B->next;
	sz = generate_legal (B);

    //    /   
	if (sz == 1)
	{
	    S->best_move = B->moves [0];
        S->score = 0;

        S->state = WAITING;
        print_score (S->score);
        uci_send ("pv %s\n", move_to_str (S->best_move));
        uci_send ("bestmove %s \n", move_to_str (S->best_move));

	    return 0;
	}
	else if (!sz) //   
	{
		if (B->check_is) return 0;
		else            return 0;
	};

    //   ,       
	order_moves (B);


    //    
    for (j = 1; j <= m_depth; j ++)
    {
        if (j >= DEPTH_TO_MOVE) uci_send ("info depth %i\n", j);

        S->search_depth = j;

        S->nodes_count ++;
        S->pv_updated = 0;

        if (step = steps[j], 0) // Disabled! ///////////////////////////////
        {
            alpha = val - step;
            beta = val + step;
        }
        else
        {
            alpha = - inf;
            beta = inf;
        };

        depth = j;

        for (i = 0; i < 256; i ++) values [i] = 0;
        for (i = 0; i < ROOT_ORDERING; i ++) best_i[i] = - 1;
        best_val[0] = best_val[1] = - inf;

        for (i = 0; i < sz; i ++)
        {
            move = make_move (i, B, N);

            // info currmove c2c3 currmovenumber 17
            if (S->search_depth >= DEPTH_TO_CURRMV)
            {
                uci_send ("info currmove %s ", move_to_str (move));
                uci_send ("currmovenumber %i\n", i + 1);
            };

            val = - nega_scout (- beta, - alpha, depth - 1, N);

            unmake_move (i, B);

            if (S->state == WAITING) return 0;

            if (val > alpha)
            {
                alpha = val;

                if (best_i [0] != i)
                {
                    for (k = ROOT_ORDERING - 1; k > 0; k --) best_i [k] = best_i [k - 1];
                    best_i [0] = i;

                    best_val [1] = best_val [0];
                    best_val [0] = val;
                };

                S->bm = move; //    ( search_root)
                S->score = val;

                // -  pv
                S->pv_start = B->hash;
                pv_write (B, N, move);

                S->pv_updated = 1;
                uci_info ();

                if (S->state == WAITING) return 0;
            };
        };

        val = alpha; // return alpha;

        //     
        for (k = 0; k < ROOT_ORDERING; k ++)
        {
            if (best_i[k] >= 0) values [best_i[k]] = ROOT_ORDERING - k;
        };

        if (S->state == WAITING) return 0;

        S->best_move = S->bm;

        if (S->best_move && is_mate (val)) break;

        // Singular Reply
        if (!S->infinite && best_val[1] != -inf && absu (best_val[0], best_val[1]) > SINGULAR_VAL)
        {
            singular ++;
            if (singular > 4)
            {
                S->best_move = B->moves [0];
                //S->score = 0;

                S->state = WAITING;
                print_score (S->score);
                uci_send ("pv %s\n", move_to_str (S->best_move));
                uci_send ("bestmove %s \n", move_to_str (S->best_move));

                return 0;
            };
        }
        else singular = 0;

        // Time management
        if (j == 2) last_val = val;
        if (j > 2)
        {
            if (last_move != S->best_move)
            {
                cnt_ch_moves ++;
                if (cnt_ch_moves > 2) S->elaps_time = (S->elaps_time + S->critl_time) >> 1; //S->is_critical = 1;

                last_move = S->best_move;
            };

            if (absu (last_val, val) > 50) S->elaps_time = (7 * S->elaps_time + S->critl_time) >> 3;  //S->is_critical = 1;
            last_val = val;
        };

        //     
        shell_sort ((int*)values, (int*)B->moves, sz);
    };

    print_score (S->score);
    uci_send ("pv %s\n", move_to_str (S->best_move));
    uci_send ("bestmove %s \n", move_to_str (S->best_move));

    return 0;
};

// Actually not in use (was integrated into IID)
int search_root (int alpha, int beta, int depth, board * B)
{
    int i, sz;
	int move;
	int val = 0;
	int n_moves = 0;

	g_hash_age ++;

	if (S->state == WAITING) return 0;

	S->ply = 0;

	board *N = B->next;

    S->search_depth = depth;
	S->nodes_count ++;
	S->pv_updated = 0;

	sz = generate (B);
	order_moves (B);

	for (i = 0; i < sz; i ++)
	{
	    move = make_move (i, B, N);
		if (!move) continue;

		n_moves ++;

		// info currmove c2c3 currmovenumber 17
		if (S->search_depth >= DEPTH_TO_CURRMV)
		{
		    uci_send ("info currmove %s ", move_to_str (move));
		    uci_send ("currmovenumber %i\n", n_moves);
		};

		val = - nega_scout (- beta, - alpha, depth - 1, N);

		unmake_move (i, B);

		if (S->state == WAITING) return 0;

		if (val > alpha)
		{
			alpha = val;

			S->bm = move;
			S->score = val;

			// -  pv
            S->pv_start = B->hash;
            pv_write (B, N, move);

            S->pv_updated = 1;
            uci_info ();

            if (S->state == WAITING) return 0;
		};
	};

	return alpha;
};

int search_ab (int alpha, int beta, int depth, int in_pv, board * B)
{
	int i, value = 0, sz;
	int depth_add = 0;
	int new_depth;
	int move;
	int best_mv = 0;
	int best = -inf;

	int num_moves = 0;
	U64 x64;

	int hash_mv = 0;

	int old_alpha = alpha;

	S->nodes_count ++;

	check_detection (B);

    if (!depth) return q_search (alpha, beta, B);

    //     ,  
    hash_retrieve (alpha, beta, hash_mv, depth, B);
    if (alpha == beta) return alpha;

	if (S->ply > MAX_DEPTH) return alpha;

	if (S->nodes_count > NODES_OF_SILENCE)
	{
	    uci_info ();
	    uci_parsing (B);

	    if (S->state == WAITING) return 0;
	};

	board * N = B->next;

	// Null Move. Thanks to Igor Korshunov (Murka2 author) -----------------------------------------
	if (!in_pv
    &&  depth >= 2
    &&  beta < inf
    &&  mat_for_null
     /*&& Eval() >= beta*/
    &&  USE_NULL_MOVE)
	{
		make_null (B, N);

		if (depth > 3) value = -search_ab (- beta, 1 - beta, depth - 3, 0, N);
		else           value = -q_search  (- beta, 1 - beta, N);

		unmake_null ();

		if (value >= beta)
		{
		    hash_update (0, value, HASH_BETA, depth, B);
			return value;
		};
	};

	// -------------------------------------------------------------------------------------------

	sz = generate (B);
	order_moves (B);

	/////////////////////////////////////
	//
	//  Extensions
    //
	// 1.  
    if (B->check_is
    //&&  S->ply + depth < S->search_depth + CHECK_PLY_LIMIT
       ) depth_add ++;

    //else

    // 2.  
    //if (sz == 1) depth_add ++;


	for (i = 0; i < sz; i ++)
	{
	    new_depth = depth + depth_add;

        move = make_move (i, B, N);
		if (!move) continue;

		num_moves ++;

		if (!threefold_repetition (N))
		{
            //    , -  
            //check_detection (N);
            //if (N->check_is                                        &&
            //    S->ply + depth < S->search_depth + CHECK_PLY_LIMIT  ) new_depth ++;

            //else

            //      
            //if (pie (S->tm) == WP                                     &&
            //    hori (from (S->tm)) > 5                               &&
            //    (S->ply + depth) < S->search_depth + PPUSH_PLY_LIMIT   ) new_depth ++;

            //else

            //if (pie (S->tm) == BP                                     &&
            //    hori (from (S->tm)) < 2                               &&
            //    (S->ply + depth) < S->search_depth + PPUSH_PLY_LIMIT   ) new_depth ++;

            //else

            //    
            //if (is_capture (S->tm)                                      &&
            //    material [squares [to(S->tm)]] <= material [pie(S->tm)] &&
            //    dist (to(S->tm), bitscan (piece [BK + !wtm])) < 3       &&
            //    (S->ply + depth) < S->search_depth + 3                   ) new_depth ++;

            check_detection (N);

            if (/*N->check_is || */!in_pv || !best_mv)
            {
                value = - search_ab (- beta, - alpha, new_depth - 1, in_pv, N);
            }
            else
            {
                value = -search_ab (- alpha - 1, - alpha, new_depth - 1, 0, N);

                if (value > alpha && value < beta)
                {
                    value = -search_ab (-beta, -value, new_depth - 1, 1, N);
                };
            };

        }
        else value = 0;

		unmake_move (i, B);

		if (S->state == WAITING) return 0;

        if (value > best)
        {
            if (value > alpha)
            {
                if (value >= beta)
                {
                    //  ,   
                    hash_update (move, value, HASH_BETA, depth, B);
                    //if (!is_capture(move) && !B->check_is) update_kihi (move, depth);

                    return value;
                };

                alpha = value;
            };

            best_mv = move;
            best    = value;

            // -  pv
            pv_write (B, N, move);
        };
	};

	//   

	if (!num_moves)
	{
		if (B->check_is) return - inf + S->ply;
		else            return 0;
	};

    if (best > old_alpha)
	{
	    //  ,   
        hash_update (best_mv, alpha, HASH_EXACT, depth, B);
        //if (!is_capture(best_mv) && !B->check_is) update_kihi (best_mv, depth);

        // -  pv
        //pv_write (B, N, best_mv);
	}
	else hash_update (best_mv, best, HASH_ALPHA, depth, B);

	return best;
};

// Thanks to CPW
int see (int mv)
{
    int gain[32], d = 0;
    U64 bb, t;
    U64 occ;
    int _from, _to;
    int piece_from;
    int piece_to;
    U64 bb_from;
    U64 bb_to;
    int col;
    U64 rq, bq, pawns;

    _to        = (mv & 0x0000FF00) >> 8;
    _from      = (mv & 0x00FF0000) >> 16;
    piece_from = (mv & 0xFF000000) >> 24;
    piece_to   = squares [_to];

    bb_from    = I << _from;

    occ = occupied [0] | occupied [1];
    rq = bq = piece [BQ] | piece [WQ];
    rq     |= piece [BR] | piece [WR];
    bq     |= piece [BB] | piece [WB];
    pawns   = piece [BP] | piece [WP];

    bb = attacked_by (occ, _to);

    gain [d] = material [piece_to];

    while (1)
    {
        d ++; // next depth and side
        gain [d] = material [piece_from] - gain [d - 1]; // speculative store, if defended

        if (max (- gain [d - 1], gain [d]) < 0) break; // pruning does not influence the result

        bb  ^= bb_from; // reset bit in set to traverse
        occ ^= bb_from; // reset bit in temporary occupancy (for x-Rays)


        //  -  !
        if      ( bb_from & pawns ) bb |= b_att (occ, _to) & occ & bq;
        else if ( bb_from & rq    ) bb |= q_att (occ, _to) & occ & rq; //   
        else if ( bb_from & bq    ) bb |= q_att (occ, _to) & occ & bq; //  

        col = d & 1;

        if      (t = bb & piece[BP + col]) bb_from = LSB(t); //    ?
        else if (t = bb & piece[BN + col]) bb_from = LSB(t);
        else if (t = bb & piece[BB + col]) bb_from = LSB(t);
        else if (t = bb & piece[BR + col]) bb_from = LSB(t);
        else if (t = bb & piece[BQ + col]) bb_from = LSB(t);
        else if (t = bb & piece[BK + col]) bb_from = LSB(t);
        else break;

        piece_from = squares [bitscan (bb_from)];
    };

    while (--d) gain [d - 1] = - max (- gain [d - 1], gain [d]);

    return gain [0];
};











int nega_scout (int alpha, int beta, int depth, board * B)
{
    int b;
    int i, sz;
    int move, bmove = 0;
    int val, bval = - inf;
    int n_moves = 0;
    int o_alpha = alpha;
    int hmove;
    U64 x64;

    S->nodes_count ++;
    board * N = B->next;

    if (!depth) return q_search (alpha, beta, B); // leaf node

    //     ,  
    hash_retrieve (alpha, beta, hmove, depth, B);
    if (alpha == beta) return alpha;

	if (S->ply > MAX_DEPTH) return alpha;

    if (S->nodes_count > NODES_OF_SILENCE)
	{
	    uci_info ();
	    uci_parsing (B);

	    if (S->state == WAITING) return 0;
	};

    check_detection (B);

	// Null Move. Thanks to Igor Korshunov (Murka2 author) -----------------------------------------
	if (!B->check_is
    &&  depth >= 2
    &&  beta < inf
    &&  mat_for_null
     /*&& Eval() >= beta*/
    &&  USE_NULL_MOVE)
	{
		make_null (B, N);

		if (depth > 3) val = -nega_scout (- beta, 1 - beta, depth - 3, N);
		else           val = -q_search   (- beta, 1 - beta, N);

		unmake_null ();

		if (val >= beta)
		{
		    hash_update (0, val, HASH_BETA, depth, B);
			return val;
		};
	};

	// -------------------------------------------------------------------------------------------



    sz = generate (B);
    order_moves (B);

    b = beta;
    for (i = 0; i < sz; i ++)
    {
        move = make_move (i, B, N);
        if (!move) continue;

        n_moves ++;

        if (!threefold_repetition (N))
        {
            val = - nega_scout (-b, -alpha, depth - 1, N);

            if (i
            &&  val > alpha
            //&&  depth > 1
            &&  val < beta) val = - nega_scout (-beta, -alpha, depth - 1, N); // re-search
        }
        else val = 0;


        unmake_move (i, B);

        if (S->state == WAITING) return 0;

        if (val > bval) // new best move
        {
            if (val > alpha) // alpha raising
            {
                alpha = val;

                if (alpha >= beta) // cut-off
                {
                    //  ,   
                    hash_update (move, val, HASH_BETA, depth, B);
                    if (!is_capture(move) && !B->check_is) update_kihi (move, depth);

                    return alpha;
                };
            };

            bval = val;
            bmove = move;

            //  pv
            pv_write (B, N, move);
        };

        b = alpha + 1; // set new null window
    };

    //   

	if (!n_moves)
	{
		if (B->check_is) return - inf + S->ply;
		else            return 0;
	};

	if (bval > o_alpha) hash_update (bmove, alpha, HASH_EXACT, depth, B);
	else                hash_update (bmove, bval, HASH_ALPHA, depth, B);

    return bval;//alpha;
};

















int q_search (int alpha, int beta, board * B)
{
	int i, value = 0, sz;
	int move;
	int best;
	int num_moves = 0;

	board * N = B->next;

	S->nodes_count ++;

    if (S->ply > MAX_DEPTH) return evaluate (B);

    check_detection (B);

    if (!B->check_is)
	{
		best = evaluate (B);
		if (best > alpha)
		{
			if (best >= beta) return best;
			alpha = best;
		};
		sz = generate_attacks (B);
	}
	else
	{
		best = - inf;
		sz   = generate (B);
	};

	order_moves (B);

	for (i = 0; i < sz; i ++)
	{
	    move = make_move (i, B, N);
		if (!move) continue;

		num_moves ++;

		if (!threefold_repetition (N)) value = - q_search (-beta, -alpha, N);
		else                           value = 0;

		unmake_move (i, B);

		if (S->state == WAITING) return 0;

		if (value > best)
		{
			if (value > alpha)
			{
				if (value >= beta) return value;
				alpha = value;
			};

			best = value;

			// -  pv
            pv_write (B, N, move);
		};
	};

    //      (  ) -   ,  
	//if (!num_moves && B->check_is) return - inf + S->ply;

	//   
	if (best == - inf) best += S->ply;

	return best;
};

S64 perft_root (int alpha, int beta, int depth, board * B)
{
	int i, sz;
	S64 perft = E;
	S64 all_nodes = E;
	clock_t curr_time;
	double perft_time;

	board *N = B->next;

    print_board (B);

    uci_send ("\n");

	if (!depth) return 1;

	sz = generate (B);

	//if (depth == 1) return sz; //   -  

	//   

	if (!sz) return 0;

    curr_time = clock ();

	for (i = 0; i < sz; i ++)
	{
	    S->tm = make_move (i, B, N);
		if (!S->tm) continue;

		print_move (S->tm);

		perft = perft_ab (-beta, -alpha, depth - 1, N);

		unmake_move (i, B);

		uci_send (" - %lld\n", perft);
        all_nodes += perft;
	};

	uci_send ("\n Totally %lld nodes\n", all_nodes);

    curr_time = clock () - curr_time;


    if (!curr_time) uci_send (" Generate time: less than 1/%i of second\n", CLOCKS_PER_SEC);
    else
    {
        perft_time = (double)curr_time / CLOCKS_PER_SEC;
        uci_send (" Generate time: %.3lf second(s)\n", (double)perft_time);
        uci_send (" %4.3lf knps\n\n", (all_nodes / perft_time) / 1000);
    };

	return perft;
};


S64 perft_ab (int alpha, int beta, int depth, board * B)
{
    if (!depth) return 1;

	int i, sz;
	S64 perft = E;

	board *N = B->next;

	sz = generate (B);

	//   

	if (!sz) return 0;

	for (i = 0; i < sz; i ++)
	{
		if (!make_move (i, B, N)) continue;

		perft += perft_ab (-beta, -alpha, depth - 1, N);

		unmake_move (i, B);
	};

	return perft;
};


inline void init_arrays ()
{
    int i, j;

    for (i = 0; i < 64; i ++)
    {
        for (j = 0; j < 64; j ++)
        {
            history [i][j] = 0;
        };
    };

    for (i = 0; i < MAX_DEPTH; i ++)
    {
        killers [i][0] = 0;
        killers [i][1] = 0;
    };
};

inline void init_uci_info ()
{
    clock_t clk;

    clk = clock ();

    S->think_time = clk;
    S->curr_time = clk;
};
